/* Attiny3led

Sketch di esempio d'uso di un ATtiny85 
Il programma legge la pressione di un pulsante
e modifica la sequenza di lampeggio dei
3 led

Sketch allegato alla guida
<<ATMEL AVR ATtiny
I microcontrollori “piccoli” di Atmel
Guida alla programmazione
valida per l'uso con le versioni 0022
dell'IDE di Arduino e del core Tiny>>
scritta da Leonardo Miliani

L'ultima versione della guida nonché del 
presente sketch è sempre scaricabile da:
www.leonardomiliani.com

Per favore diffondi lo sketch 
allegando la guida su citata

Se non hai ottenuto una copia della licenza,
puoi scaricarla dal sito www.fsf.org

Il presente codice è rilasciato sotto licenza 
GNU GPL v.3.0 o successive

*/

#define RED 2
#define YELLOW 1
#define GREEN 0
#define BUTTON 4

byte value=1;
byte state=0;

byte val1=0;
byte val2=0;
byte change=0;
byte sequence=0;
unsigned long timer;

void setup() {
    pinMode(RED, OUTPUT);
    pinMode(YELLOW, OUTPUT);
    pinMode(GREEN, OUTPUT);
    pinMode(BUTTON, INPUT);
}

void loop() {
    //funzione di Debounce per il pulsantino - da qui....
    val1=digitalRead(BUTTON);
    delay(10);
    val2=digitalRead(BUTTON);
    if (val1==val2) {
        if (val1!=change) {
            if (val1==LOW) {
                write_leds(LOW, LOW, LOW);
                value++;
                if (value>5) { value=0; }
                sequence = 0;
                timer=millis()-100;
            }
        }
    }
    //...a qui
    //controlla se non sia ora di far lampeggiare un LED
    change=val1;
    if (millis() > timer) {
        timer = millis()+500;
        switch (value) {
            case 0:
                //tutti spenti
                write_leds(LOW, LOW, LOW);
                break;
            case 1:
                //alterna il LED rosso
                if (sequence == 0) {
                    write_leds(LOW, LOW, LOW);
                } else {
                    write_leds(HIGH, LOW, LOW);
                }
                sequence ^= 1;
                break;
            case 2:
                //alterna il LED giallo
                if (sequence == 0) {
                    write_leds(LOW, LOW, LOW);
                } else {
                    write_leds(LOW, HIGH, LOW);
                }
                sequence ^= 1;
                break;
            case 3:
                //alterna il LED verde
                if (sequence == 0) {
                    write_leds(LOW, LOW, LOW);
                } else {
                    write_leds(LOW, LOW, HIGH);
                }
                sequence ^= 1;
                break;
            case 4:
                //alterna i 3 LED in sequenza
                switch (sequence) {
                    case 0:
                        write_leds(HIGH, LOW, LOW);
                        break;
                    case 1:
                        write_leds(LOW, HIGH, LOW);
                        break;
                    case 2:
                        write_leds(LOW, LOW, HIGH);
                        break;
                }
                sequence++;
                if (sequence > 2) { sequence = 0; }
                break;
            case 5:
                //tutti accesi
                write_leds(HIGH, HIGH, HIGH);
                break;
        }
    }
}

void write_leds(byte state1, byte state2, byte state3) {
    //modifica le porte dei 3 LED
    digitalWrite(RED, state1);
    digitalWrite(YELLOW, state2);
    digitalWrite(GREEN, state3);
}
