/* AttinySeriale

Sketch di esempio d'uso di un ATtiny85 
Il programma legge la pressione di 2 pulsanti
ed invia sia seriale un valore all'Arduino
che poi lo stampa su terminale

Sketch allegato alla guida
<<ATMEL AVR ATtiny
I microcontrollori “piccoli” di Atmel
Guida alla programmazione
valida per l'uso con le versioni 0022
dell'IDE di Arduino e del core Tiny>>
scritta da Leonardo Miliani

L'ultima versione della guida nonché del 
presente sketch è sempre scaricabile da:
www.leonardomiliani.com

Per favore diffondi lo sketch 
allegando la guida su citata

Se non hai ottenuto una copia della licenza,
puoi scaricarla dal sito www.fsf.org

Il presente codice è rilasciato sotto licenza 
GNU GPL v.3.0 o successive

*/

#include <NewSoftSerial.h>

#define BUTTON1 3
#define BUTTON2 4
#define RX_PIN 0
#define TX_PIN 1

NewSoftSerial mySerial(RX_PIN, TX_PIN);

byte val11=0;
byte val12=0;
byte val21=0;
byte val22=0;
byte change1=0;
byte change2=0;

void setup() {
  pinMode(BUTTON1, INPUT);
  pinMode(BUTTON2, INPUT);
  mySerial.begin(9600);
}

void loop() {
  //funzione di Debounce per i pulsantini - da qui....
  val11=digitalRead(BUTTON1);
  delay(10);
  val12=digitalRead(BUTTON1);
  if (val11==val12) {
    if (val11!=change1) {
      if (val11==LOW) {
        mySerial.print("1");
      }
    }
  }
  change1=val11;
  val21=digitalRead(BUTTON2);
  delay(10);
  val22=digitalRead(BUTTON2);
  if (val21==val22) {
    if (val21!=change2) {
      if (val21==LOW) {
        mySerial.print("2");
      }
    }
  }
  change2=val21;
  //...a qui
}
